import { ActionRowBuilder, ButtonBuilder, ButtonInteraction, ButtonStyle, CacheType, CommandInteraction, InteractionUpdateOptions } from "discord.js";
import { Command } from "./command";
import EmbedPage from "./embedPage";

export class PaginatedCommand<TPage extends EmbedPage> extends Command {
    public CommandBuilder: any;
    public pages: TPage[];

    constructor() {
        super();
    }

    public async sendCommandEmbed(interaction: CommandInteraction, index: number) {
        await interaction.reply({
            embeds: [ this.pages[index] ],
            components: [ this.pages[index].row ],
        });
    }

    public async sendButtonEmbed(interaction: ButtonInteraction, index: number) {
        await interaction.update({
            embeds: [ this.pages[index] ],
            components: [ this.pages[index].row ],
        });
        return;
    }
}
